
#ifdef __cplusplus
extern "C" {
#endif

#include <PA9.h>
#include "arm9/PA_Splash.h"



#define PA_EYE_X 119
#define PA_EYE_Y 32

// Sprites :
const unsigned char pa_black_Sprite[64];

const unsigned char pa_eye_Sprite[2048];


const unsigned short pa_splspr_Pal[88];

extern const u8 pa_splasheyes[];
extern const u32 pa_splasheyes_size[];

// Background
const int pa_splasheyes_Info[3] = {2, 256, 192};;
const unsigned short pa_splasheyes_Map[768];
const unsigned char pa_splasheyes_Tiles[8704];
const unsigned short pa_splasheyes_Pal[17] __attribute__ ((aligned (4))) = {
64543, 65535, 57079, 32768, 45452, 63421, 39110, 54965, 36996, 52851, 47566, 34882, 50737, 41224, 59193, 43338, 61307};

// Function: main()
void PA_SplashEyes(void){
	PA_SetBrightness(0, 31); 	PA_SetBrightness(1, 31);
	
	
	u8 screen;
	
	float pa_eyey[2][2];
	float pa_eyevy[2][2];	
	
	for (screen = 0; screen < 2; screen++){
		PA_Init8bitBg(screen, 0);  
		PA_LoadTiledBg(screen, 0, pa_splasheyes);		
		PA_LoadSpritePal(screen, 0, (void*)pa_splspr_Pal);
		
		pa_eyey[screen][0] = PA_EYE_Y; 		pa_eyey[screen][1] = PA_EYE_Y;
		pa_eyevy[screen][0] = -0.5; 		pa_eyevy[screen][1] = -0.5;
				
		PA_CreateSprite(screen, 10, (void*)pa_eye_Sprite, OBJ_SIZE_32X64, 1, 0, PA_EYE_X, PA_EYE_Y);
		PA_CloneSprite(screen, 9, 10); PA_SetSpriteXY(screen, 9, PA_EYE_X+26, PA_EYE_Y);

		PA_CreateSprite(screen, 0, (void*)pa_black_Sprite, OBJ_SIZE_8X8, 1, 0, PA_EYE_X+6, PA_EYE_Y+6);
		PA_CloneSprite(screen, 1, 0); PA_SetSpriteXY(screen, 1, PA_EYE_X+26+10, PA_EYE_Y+10);		
	}	
	
	s8 i;
	for (i = 31; i >= 0; i--) {
	   PA_SetBrightness(0, i);
	   PA_SetBrightness(1, i);	   
	   PA_WaitForVBL();
	}
	
	PA_InitRand();
	
	  PA_WaitForVBL();

	while (!Pad.Released.Anykey)  // Stop when any key pressed
	{
	   for (screen = 0; screen < 2; screen++){
	      for (i = 0; i < 2; i++){
	         if((pa_eyey[screen][i] > PA_EYE_Y) || (pa_eyey[screen][i] < PA_EYE_Y-30)) pa_eyevy[screen][i] = -pa_eyevy[screen][i];
	         else if ((PA_Rand()&63) == 0) pa_eyevy[screen][i] = -pa_eyevy[screen][i];
	         pa_eyey[screen][i] += pa_eyevy[screen][i];
	   		PA_SetSpriteY(screen, 10-i, (s16)pa_eyey[screen][i]);
	   		s16 angle = PA_GetAngle(PA_EYE_X+(26*i)+14, PA_EYE_Y+10, Stylus.X, Stylus.Y+(screen*192)
				
				);
	   		PA_SetSpriteXY(screen, i, PA_EYE_X+(26*i)+10+(PA_Cos(angle)>>6), pa_eyey[screen][i]+10-(PA_Sin(angle)>>6));
		 	}
		}	   	
	   
		PA_WaitForVBL();
	}
	

// fade out
	for (i = 0; i < 31; i++) {
	   PA_SetBrightness(0, i);
	   PA_SetBrightness(1, i);	   
	   PA_WaitForVBL();
	}
	
	// Reset everything
	PA_ResetSpriteSys(); 
	PA_ResetBgSys(); 
	PA_SetBrightness(0, 0); // Bacl to normal
	PA_SetBrightness(1, 0); // Back to normal
	   
	   
}


// Sprites :
const unsigned char pa_black_Sprite[64] __attribute__ ((aligned (4))) = {
34, 34, 44, 50, 73, 7, 40, 34, 34, 7, 6, 74, 71, 75, 76, 44, 
44, 77, 78, 71, 71, 71, 6, 79, 77, 80, 71, 71, 71, 71, 81, 82, 
72, 71, 71, 71, 71, 71, 71, 71, 77, 83, 71, 71, 71, 71, 71, 71, 
42, 84, 81, 71, 71, 71, 80, 85, 34, 50, 77, 86, 71, 82, 87, 73
};



const unsigned char pa_eye_Sprite[2048] __attribute__ ((aligned (4))) = {
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 25, 38, 
0, 0, 0, 0, 0, 41, 5, 42, 0, 0, 0, 0, 25, 5, 44, 34, 
0, 0, 0, 1, 2, 3, 4, 5, 0, 0, 8, 9, 10, 11, 11, 12, 
0, 14, 16, 17, 18, 19, 20, 17, 21, 18, 24, 25, 26, 6, 8, 27, 
9, 8, 30, 31, 32, 33, 34, 7, 15, 34, 39, 34, 40, 40, 40, 34, 
34, 40, 40, 40, 40, 40, 34, 34, 34, 34, 33, 33, 33, 33, 34, 34, 
6, 4, 2, 7, 0, 0, 0, 0, 12, 12, 13, 14, 6, 15, 0, 0, 
17, 17, 17, 17, 11, 21, 22, 23, 28, 17, 11, 17, 17, 17, 17, 29, 
35, 5, 36, 17, 17, 17, 17, 17, 34, 33, 33, 15, 9, 11, 10, 17, 
34, 34, 34, 33, 43, 36, 9, 10, 34, 34, 34, 34, 33, 45, 25, 11, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 
11, 37, 0, 0, 0, 0, 0, 0, 17, 21, 30, 0, 0, 0, 0, 0, 
17, 17, 14, 15, 0, 0, 0, 0, 17, 17, 11, 22, 46, 0, 0, 0, 
0, 0, 0, 25, 22, 44, 34, 34, 0, 0, 49, 41, 31, 33, 40, 34, 
0, 0, 11, 51, 34, 40, 34, 33, 0, 0, 25, 35, 33, 40, 34, 33, 
0, 25, 26, 1, 34, 40, 33, 34, 0, 4, 5, 32, 34, 40, 33, 33, 
0, 26, 2, 33, 40, 40, 33, 33, 0, 8, 2, 33, 40, 40, 33, 33, 
34, 33, 33, 33, 34, 34, 34, 34, 33, 33, 33, 34, 34, 34, 34, 34, 
34, 33, 34, 34, 34, 34, 34, 34, 33, 33, 34, 34, 34, 34, 34, 34, 
33, 34, 34, 34, 34, 34, 34, 34, 33, 34, 34, 34, 34, 34, 34, 34, 
33, 34, 33, 33, 33, 33, 33, 33, 33, 34, 34, 34, 34, 34, 34, 34, 
34, 34, 34, 34, 34, 33, 47, 17, 34, 34, 34, 34, 34, 34, 34, 5, 
34, 34, 34, 34, 34, 34, 34, 44, 34, 34, 34, 34, 34, 34, 34, 34, 
34, 34, 34, 34, 34, 33, 34, 34, 33, 34, 33, 33, 34, 33, 34, 40, 
33, 34, 34, 33, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 
11, 17, 17, 29, 48, 0, 0, 0, 11, 17, 17, 17, 14, 50, 0, 0, 
11, 11, 17, 17, 11, 49, 0, 0, 52, 14, 17, 17, 17, 21, 53, 0, 
54, 14, 17, 17, 17, 10, 8, 0, 1, 9, 17, 17, 17, 17, 38, 0, 
32, 55, 17, 17, 17, 17, 38, 0, 32, 56, 17, 17, 17, 17, 26, 0, 
0, 3, 57, 46, 34, 40, 33, 33, 0, 24, 27, 1, 39, 40, 33, 33, 
0, 0, 24, 53, 33, 40, 33, 33, 0, 0, 11, 4, 34, 40, 34, 33, 
0, 0, 0, 25, 60, 33, 40, 33, 0, 0, 0, 8, 26, 61, 34, 34, 
0, 0, 0, 0, 27, 6, 7, 34, 0, 0, 0, 0, 0, 28, 8, 45, 
33, 34, 34, 34, 40, 40, 34, 34, 33, 34, 34, 34, 34, 34, 34, 34, 
33, 33, 34, 34, 33, 34, 34, 34, 33, 33, 34, 34, 34, 34, 34, 34, 
33, 33, 33, 33, 34, 34, 34, 34, 33, 33, 33, 33, 33, 33, 33, 33, 
34, 33, 33, 33, 33, 33, 33, 33, 40, 40, 34, 33, 33, 33, 33, 33, 
40, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 40, 
34, 34, 34, 34, 34, 34, 34, 43, 34, 34, 34, 34, 34, 33, 34, 50, 
34, 34, 34, 33, 33, 33, 32, 49, 33, 33, 33, 33, 33, 40, 30, 36, 
33, 33, 33, 34, 40, 2, 14, 29, 33, 34, 40, 62, 54, 21, 11, 17, 
15, 36, 17, 17, 17, 10, 6, 0, 3, 38, 17, 17, 17, 11, 2, 0, 
58, 14, 17, 17, 17, 14, 59, 0, 36, 11, 17, 17, 17, 57, 0, 0, 
36, 17, 17, 17, 21, 50, 0, 0, 11, 17, 17, 10, 49, 0, 0, 0, 
17, 17, 17, 21, 0, 0, 0, 0, 17, 17, 17, 54, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 20, 25, 0, 0, 0, 0, 0, 0, 0, 24, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
47, 40, 34, 40, 40, 40, 40, 40, 24, 38, 51, 60, 44, 33, 40, 50, 
57, 17, 16, 41, 38, 26, 8, 6, 0, 64, 11, 21, 20, 18, 20, 17, 
0, 0, 11, 10, 10, 65, 18, 20, 0, 0, 51, 11, 10, 10, 17, 10, 
0, 0, 0, 64, 11, 17, 10, 11, 0, 0, 0, 0, 21, 17, 13, 13, 
34, 40, 7, 57, 36, 11, 17, 17, 54, 52, 58, 63, 11, 17, 17, 17, 
11, 11, 17, 17, 17, 17, 17, 14, 17, 17, 17, 17, 24, 11, 58, 48, 
20, 20, 17, 11, 11, 21, 66, 0, 10, 10, 10, 11, 13, 51, 0, 0, 
10, 10, 10, 11, 67, 0, 0, 0, 13, 13, 10, 9, 0, 0, 0, 0, 
17, 17, 22, 0, 0, 0, 0, 0, 17, 5, 0, 0, 0, 0, 0, 0, 
35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 41, 13, 13, 0, 0, 0, 0, 0, 4, 13, 13, 
0, 0, 0, 0, 0, 4, 68, 13, 0, 0, 0, 0, 0, 30, 69, 69, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
13, 13, 10, 26, 0, 0, 0, 0, 13, 13, 14, 0, 0, 0, 0, 0, 
13, 68, 48, 0, 0, 0, 0, 0, 69, 69, 22, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
0, 0, 0, 0, 0, 70, 71, 71, 0, 0, 0, 0, 0, 70, 71, 71, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
71, 71, 72, 0, 0, 0, 0, 0, 71, 71, 72, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};


const unsigned short pa_splspr_Pal[88] __attribute__ ((aligned (4))) = {
64543, 58137, 53909, 51795, 50738, 49714, 49681, 60250, 48624, 43372, 41292, 42316, 42317, 42349, 44430, 57080, 42283, 41259, 40202, 39145, 41258, 43373, 47600, 56023, 42315, 44429, 47567, 46510, 43340, 42348, 52884, 57112, 62364, 65535, 64478, 54966, 45486, 50739, 46511, 65534, 63421, 45454, 60283, 61308, 61307, 59194, 61340, 54998, 51796, 48657, 59193, 50771, 46543, 53942, 52852, 43339, 44397, 49682, 45487, 59226, 56055, 60251, 62397, 43405, 47601, 41291, 51828, 46544, 43406, 39177, 57079, 32768, 45452, 56022, 41224, 45453, 58136, 48623, 35939, 54965, 33825, 34882, 36996, 32769, 47566, 43338, 39111, 46509};
	   
	   

const unsigned short pa_splasheyes_Map[768] __attribute__ ((aligned (4))) = {
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
1, 2, 0, 3, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
5, 6, 0, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
5, 6, 0, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
5, 6, 0, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
5, 9, 10, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
5, 6, 11, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 
5, 6, 24, 7, 25, 26, 27, 28, 29, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 30, 31, 32, 0, 33, 34, 35, 36, 0, 0, 37, 8, 
5, 6, 38, 7, 39, 40, 0, 41, 42, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 30, 43, 0, 0, 0, 44, 45, 46, 0, 0, 47, 8, 
5, 6, 38, 7, 48, 0, 0, 0, 49, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 30, 50, 51, 0, 52, 53, 54, 55, 0, 0, 56, 8, 
5, 6, 38, 7, 57, 58, 0, 59, 60, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 30, 61, 62, 63, 64, 65, 2066, 66, 67, 68, 69, 2071, 
70, 71, 2072, 72, 73, 74, 75, 76, 2077, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 30, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 78, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 30, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 
80, 81, 82, 83, 84, 85, 86, 87, 88, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 30, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 
90, 91, 92, 93, 94, 95, 96, 97, 98, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 30, 77, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 
109, 110, 111, 112, 113, 114, 115, 116, 117, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 30, 77, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 
128, 129, 130, 131, 132, 133, 134, 0, 135, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

const unsigned char pa_splasheyes_Tiles[8704] __attribute__ ((aligned (4))) = {
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 3, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 1, 
1, 1, 1, 1, 2, 3, 3, 3, 1, 1, 1, 1, 2, 3, 3, 3, 
1, 1, 1, 1, 2, 3, 3, 3, 1, 1, 1, 1, 2, 3, 3, 3, 
1, 1, 1, 1, 2, 3, 3, 3, 1, 1, 1, 1, 2, 3, 3, 3, 
1, 1, 1, 1, 2, 3, 3, 3, 1, 1, 1, 1, 2, 3, 3, 3, 
3, 4, 1, 1, 1, 1, 1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 
3, 4, 1, 1, 1, 1, 1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 
3, 4, 1, 1, 1, 1, 1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 
3, 4, 1, 1, 1, 1, 1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 1, 1, 1, 2, 3, 
3, 3, 3, 4, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 1, 
3, 3, 3, 4, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 1, 
3, 3, 3, 4, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 1, 
3, 3, 3, 4, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 1, 
3, 4, 1, 1, 1, 1, 1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 
3, 4, 1, 1, 1, 1, 1, 5, 3, 4, 1, 1, 1, 1, 1, 10, 
3, 4, 1, 1, 1, 1, 1, 6, 3, 4, 1, 1, 1, 1, 1, 6, 
3, 4, 1, 1, 1, 1, 1, 10, 3, 4, 1, 1, 1, 1, 1, 5, 
1, 1, 1, 1, 1, 1, 1, 1, 5, 4, 3, 3, 6, 7, 1, 1, 
8, 3, 3, 3, 3, 3, 9, 1, 3, 3, 3, 3, 3, 3, 11, 5, 
3, 3, 3, 3, 3, 3, 3, 2, 3, 3, 3, 3, 3, 3, 3, 2, 
3, 3, 3, 3, 3, 3, 11, 5, 8, 3, 3, 3, 3, 3, 9, 1, 
5, 4, 3, 3, 6, 7, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 12, 3, 
1, 1, 1, 1, 1, 1, 12, 3, 1, 1, 1, 1, 1, 1, 12, 3, 
1, 1, 1, 1, 1, 1, 12, 3, 1, 1, 1, 1, 1, 1, 12, 3, 
1, 1, 1, 1, 1, 1, 12, 3, 1, 1, 1, 1, 1, 1, 12, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 12, 1, 1, 1, 1, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 3, 3, 12, 1, 1, 1, 2, 
3, 3, 3, 12, 1, 1, 9, 3, 3, 3, 3, 12, 1, 12, 3, 3, 
3, 3, 3, 12, 9, 3, 3, 3, 3, 3, 3, 15, 3, 3, 3, 3, 
1, 1, 1, 1, 1, 9, 12, 13, 1, 1, 14, 4, 3, 3, 3, 3, 
5, 4, 3, 3, 3, 3, 3, 3, 11, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 15, 12, 14, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 15, 5, 1, 1, 1, 1, 1, 
3, 3, 3, 3, 3, 11, 12, 12, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 1, 1, 1, 1, 1, 12, 12, 11, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
5, 1, 1, 1, 1, 1, 1, 1, 3, 6, 12, 1, 1, 1, 1, 1, 
3, 3, 3, 11, 9, 1, 1, 1, 3, 3, 3, 3, 3, 13, 5, 1, 
3, 3, 3, 3, 3, 3, 8, 14, 3, 3, 3, 3, 3, 3, 3, 3, 
7, 13, 3, 3, 3, 3, 3, 3, 1, 1, 7, 11, 3, 3, 3, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 
3, 14, 1, 1, 1, 1, 1, 1, 3, 11, 16, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 
1, 1, 1, 1, 1, 2, 6, 3, 1, 1, 1, 1, 15, 3, 3, 3, 
1, 1, 16, 6, 3, 3, 3, 3, 1, 14, 11, 3, 3, 3, 3, 3, 
16, 11, 3, 3, 3, 3, 3, 3, 8, 3, 3, 3, 3, 3, 3, 12, 
1, 1, 12, 12, 8, 3, 3, 3, 13, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 12, 12, 1, 1, 1, 
8, 9, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
3, 3, 6, 12, 12, 1, 1, 1, 3, 3, 3, 3, 3, 3, 15, 2, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 1, 1, 5, 12, 10, 3, 3, 3, 
1, 1, 1, 1, 1, 1, 12, 8, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 
13, 16, 1, 1, 1, 1, 2, 3, 3, 3, 9, 1, 1, 1, 2, 3, 
3, 3, 3, 10, 1, 1, 2, 3, 3, 3, 3, 3, 4, 1, 2, 3, 
3, 3, 3, 3, 3, 12, 2, 3, 10, 3, 3, 3, 3, 3, 10, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 1, 
3, 3, 3, 4, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 1, 
3, 3, 3, 4, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 1, 
3, 3, 3, 4, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 16, 3, 3, 3, 3, 4, 1, 1, 
16, 3, 3, 3, 3, 4, 1, 1, 16, 3, 3, 3, 3, 4, 1, 1, 
16, 3, 3, 3, 3, 4, 1, 1, 16, 3, 3, 3, 3, 4, 1, 1, 
16, 3, 3, 3, 3, 4, 1, 1, 16, 3, 3, 3, 3, 4, 1, 1, 
3, 3, 3, 4, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 1, 
3, 3, 3, 4, 1, 1, 1, 1, 3, 3, 3, 4, 1, 1, 1, 14, 
3, 3, 3, 4, 1, 1, 7, 3, 3, 3, 3, 4, 1, 12, 3, 3, 
3, 3, 3, 4, 9, 3, 3, 3, 3, 3, 3, 8, 3, 3, 3, 3, 
1, 1, 1, 1, 1, 14, 12, 10, 1, 1, 5, 12, 11, 3, 3, 3, 
1, 10, 3, 3, 3, 3, 3, 3, 8, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 8, 12, 9, 
3, 3, 3, 15, 14, 1, 1, 1, 3, 6, 2, 1, 1, 1, 1, 1, 
3, 3, 3, 3, 3, 3, 4, 12, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 1, 1, 1, 1, 1, 7, 12, 8, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
2, 1, 1, 1, 1, 1, 1, 1, 3, 3, 12, 5, 1, 1, 1, 1, 
3, 3, 3, 3, 10, 1, 1, 1, 3, 3, 3, 3, 3, 8, 2, 1, 
3, 3, 3, 3, 3, 3, 3, 12, 3, 3, 3, 3, 3, 3, 3, 3, 
2, 15, 3, 3, 3, 3, 3, 3, 1, 1, 2, 8, 3, 3, 3, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 12, 1, 1, 1, 1, 1, 1, 1, 
3, 12, 1, 1, 1, 1, 1, 1, 3, 3, 7, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 12, 3, 1, 1, 1, 1, 1, 1, 12, 3, 
1, 1, 1, 1, 1, 1, 12, 3, 1, 1, 1, 1, 1, 1, 12, 3, 
1, 1, 1, 1, 1, 1, 12, 3, 1, 1, 1, 1, 1, 1, 12, 3, 
1, 1, 1, 1, 1, 1, 12, 3, 1, 1, 1, 1, 1, 1, 12, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 9, 
3, 3, 3, 3, 3, 3, 12, 1, 3, 3, 3, 3, 3, 15, 1, 1, 
3, 3, 3, 3, 11, 5, 1, 1, 3, 3, 3, 3, 12, 1, 1, 1, 
3, 3, 3, 3, 5, 1, 1, 1, 3, 3, 3, 13, 1, 1, 1, 1, 
12, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 16, 6, 3, 3, 3, 1, 1, 1, 1, 5, 6, 3, 3, 
1, 1, 1, 1, 1, 5, 8, 3, 1, 1, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 16, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
3, 3, 6, 1, 1, 1, 1, 1, 3, 3, 3, 12, 1, 1, 1, 1, 
3, 3, 3, 11, 16, 1, 1, 1, 3, 3, 3, 3, 4, 1, 1, 1, 
3, 3, 3, 3, 11, 5, 1, 1, 3, 3, 3, 3, 3, 9, 1, 1, 
4, 3, 3, 3, 3, 15, 1, 1, 7, 3, 3, 3, 3, 11, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 15, 1, 1, 1, 1, 1, 1, 9, 3, 
1, 1, 1, 1, 1, 5, 8, 3, 1, 1, 1, 1, 1, 12, 3, 3, 
1, 1, 1, 1, 1, 8, 3, 3, 1, 1, 1, 1, 2, 3, 3, 3, 
1, 1, 1, 1, 10, 3, 3, 3, 1, 1, 1, 1, 6, 3, 3, 3, 
3, 3, 3, 3, 3, 8, 14, 1, 3, 3, 3, 3, 8, 16, 1, 1, 
3, 3, 3, 11, 14, 1, 1, 1, 3, 3, 3, 9, 1, 1, 1, 1, 
3, 3, 13, 1, 1, 1, 1, 1, 3, 3, 2, 1, 1, 1, 1, 1, 
3, 13, 1, 1, 1, 1, 1, 1, 3, 12, 1, 1, 1, 1, 1, 1, 
1, 2, 3, 3, 3, 3, 3, 3, 1, 1, 14, 3, 3, 3, 3, 3, 
1, 1, 1, 7, 3, 3, 3, 3, 1, 1, 1, 1, 10, 3, 3, 3, 
1, 1, 1, 1, 1, 8, 3, 3, 1, 1, 1, 1, 1, 9, 3, 3, 
1, 1, 1, 1, 1, 1, 11, 3, 1, 1, 1, 1, 1, 1, 10, 3, 
16, 3, 3, 3, 3, 4, 1, 1, 16, 3, 3, 3, 3, 4, 1, 1, 
16, 3, 3, 3, 3, 4, 1, 1, 16, 3, 3, 3, 3, 4, 1, 1, 
16, 3, 3, 3, 3, 4, 1, 1, 16, 3, 3, 3, 3, 4, 1, 1, 
16, 3, 3, 3, 3, 4, 1, 1, 16, 3, 3, 3, 3, 4, 1, 1, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 12, 
3, 3, 3, 3, 3, 3, 4, 1, 3, 3, 3, 3, 3, 8, 1, 1, 
3, 3, 3, 3, 3, 2, 1, 1, 3, 3, 3, 3, 13, 1, 1, 1, 
3, 3, 3, 3, 7, 1, 1, 1, 3, 3, 3, 11, 1, 1, 1, 1, 
15, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 5, 13, 3, 3, 3, 1, 1, 1, 1, 1, 13, 3, 3, 
1, 1, 1, 1, 1, 1, 6, 3, 1, 1, 1, 1, 1, 1, 16, 11, 
1, 1, 1, 1, 1, 1, 1, 12, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
3, 3, 11, 16, 1, 1, 1, 1, 3, 3, 3, 13, 1, 1, 1, 1, 
3, 3, 3, 3, 7, 1, 1, 1, 3, 3, 3, 3, 6, 1, 1, 1, 
3, 3, 3, 3, 3, 2, 1, 1, 8, 3, 3, 3, 3, 10, 1, 1, 
12, 3, 3, 3, 3, 11, 1, 1, 5, 3, 3, 3, 3, 3, 14, 1, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 3, 3, 7, 1, 1, 1, 1, 
3, 3, 3, 14, 1, 1, 1, 1, 3, 3, 3, 16, 1, 1, 1, 1, 
3, 3, 3, 16, 1, 1, 1, 1, 3, 3, 3, 14, 1, 1, 1, 1, 
3, 3, 3, 7, 1, 1, 1, 1, 3, 3, 3, 12, 1, 1, 1, 1, 
1, 11, 3, 3, 3, 3, 16, 1, 1, 6, 3, 3, 3, 3, 2, 1, 
1, 4, 3, 3, 3, 3, 9, 1, 1, 4, 3, 3, 3, 3, 9, 1, 
1, 4, 3, 3, 3, 3, 9, 1, 1, 15, 3, 3, 3, 3, 7, 1, 
1, 6, 3, 3, 3, 3, 2, 1, 5, 3, 3, 3, 3, 3, 5, 1, 
1, 1, 1, 1, 11, 3, 3, 3, 1, 1, 1, 16, 3, 3, 3, 3, 
1, 1, 1, 14, 3, 3, 3, 3, 1, 1, 1, 2, 3, 3, 3, 3, 
1, 1, 1, 2, 3, 3, 3, 3, 1, 1, 1, 14, 3, 3, 3, 3, 
1, 1, 1, 5, 3, 3, 3, 3, 1, 1, 1, 1, 11, 3, 3, 3, 
3, 5, 1, 1, 1, 1, 1, 1, 11, 1, 1, 1, 1, 1, 1, 1, 
13, 1, 1, 1, 1, 1, 1, 1, 13, 1, 1, 1, 1, 1, 1, 1, 
13, 1, 1, 1, 1, 1, 1, 1, 6, 1, 1, 1, 1, 1, 1, 1, 
11, 1, 1, 1, 1, 1, 1, 1, 3, 14, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 7, 3, 1, 1, 1, 1, 1, 1, 14, 3, 
1, 1, 1, 1, 1, 1, 5, 3, 1, 1, 1, 1, 1, 1, 1, 3, 
1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 
1, 1, 1, 1, 1, 1, 16, 3, 1, 1, 1, 1, 1, 1, 7, 3, 
3, 3, 3, 15, 1, 1, 1, 1, 3, 3, 3, 10, 1, 1, 1, 1, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 3, 3, 9, 1, 1, 1, 1, 
3, 3, 3, 9, 1, 1, 1, 1, 3, 3, 3, 12, 1, 1, 1, 1, 
3, 3, 3, 10, 1, 1, 1, 1, 3, 3, 3, 15, 1, 1, 1, 1, 
1, 6, 3, 3, 3, 3, 7, 1, 1, 10, 3, 3, 3, 3, 12, 1, 
1, 12, 3, 3, 3, 3, 10, 1, 1, 9, 3, 3, 3, 3, 4, 1, 
1, 9, 3, 3, 3, 3, 4, 1, 1, 9, 3, 3, 3, 3, 10, 1, 
1, 10, 3, 3, 3, 3, 12, 1, 1, 15, 3, 3, 3, 3, 7, 1, 
3, 3, 3, 15, 1, 1, 1, 1, 3, 3, 3, 3, 5, 1, 1, 1, 
3, 3, 3, 3, 12, 1, 1, 1, 3, 3, 3, 3, 11, 5, 1, 1, 
3, 3, 3, 3, 3, 10, 1, 1, 3, 3, 3, 3, 3, 3, 7, 1, 
3, 3, 3, 3, 3, 3, 3, 2, 3, 3, 3, 3, 3, 3, 3, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 7, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 16, 1, 1, 1, 1, 1, 1, 1, 15, 
1, 1, 1, 1, 1, 1, 7, 3, 1, 1, 1, 1, 1, 16, 11, 3, 
1, 1, 1, 1, 16, 8, 3, 3, 1, 1, 1, 14, 8, 3, 3, 3, 
7, 3, 3, 3, 3, 11, 1, 1, 15, 3, 3, 3, 3, 15, 1, 1, 
3, 3, 3, 3, 3, 7, 1, 1, 3, 3, 3, 3, 11, 5, 1, 1, 
3, 3, 3, 3, 10, 1, 1, 1, 3, 3, 3, 11, 16, 1, 1, 1, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 3, 6, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 6, 3, 3, 3, 1, 1, 1, 1, 10, 3, 3, 3, 
1, 1, 1, 1, 14, 3, 3, 3, 1, 1, 1, 1, 1, 8, 3, 3, 
1, 1, 1, 1, 1, 12, 3, 3, 1, 1, 1, 1, 1, 5, 8, 3, 
1, 1, 1, 1, 1, 1, 9, 3, 1, 1, 1, 1, 1, 1, 1, 15, 
3, 12, 1, 1, 1, 1, 1, 1, 3, 6, 1, 1, 1, 1, 1, 1, 
3, 3, 2, 1, 1, 1, 1, 1, 3, 3, 6, 1, 1, 1, 1, 1, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 3, 3, 3, 14, 1, 1, 1, 
3, 3, 3, 3, 11, 14, 1, 1, 3, 3, 3, 3, 3, 11, 2, 1, 
1, 1, 1, 1, 1, 1, 10, 3, 1, 1, 1, 1, 1, 1, 8, 3, 
1, 1, 1, 1, 1, 7, 3, 3, 1, 1, 1, 1, 1, 6, 3, 3, 
1, 1, 1, 1, 12, 3, 3, 3, 1, 1, 1, 14, 3, 3, 3, 3, 
1, 1, 14, 11, 3, 3, 3, 3, 1, 2, 11, 3, 3, 3, 3, 3, 
3, 3, 3, 11, 1, 1, 1, 1, 3, 3, 3, 3, 7, 1, 1, 1, 
3, 3, 3, 3, 13, 1, 1, 1, 3, 3, 3, 3, 3, 2, 1, 1, 
3, 3, 3, 3, 3, 8, 5, 1, 3, 3, 3, 3, 3, 3, 15, 1, 
3, 3, 3, 3, 3, 3, 3, 10, 3, 3, 3, 3, 3, 3, 3, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 
1, 1, 1, 1, 1, 1, 5, 8, 1, 1, 1, 1, 1, 1, 15, 3, 
1, 1, 1, 1, 1, 4, 3, 3, 1, 1, 1, 1, 15, 3, 3, 3, 
5, 3, 3, 3, 3, 3, 14, 1, 9, 3, 3, 3, 3, 11, 1, 1, 
8, 3, 3, 3, 3, 4, 1, 1, 3, 3, 3, 3, 3, 2, 1, 1, 
3, 3, 3, 3, 6, 1, 1, 1, 3, 3, 3, 3, 7, 1, 1, 1, 
3, 3, 3, 13, 1, 1, 1, 1, 3, 3, 11, 16, 1, 1, 1, 1, 
3, 3, 3, 8, 3, 3, 3, 3, 3, 3, 3, 12, 4, 3, 3, 3, 
3, 3, 3, 12, 1, 4, 3, 3, 3, 3, 3, 12, 1, 1, 10, 3, 
3, 3, 3, 12, 1, 1, 1, 7, 3, 3, 3, 12, 1, 1, 1, 1, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 3, 3, 12, 1, 1, 1, 1, 
3, 15, 5, 1, 1, 1, 1, 1, 3, 3, 3, 10, 5, 1, 1, 1, 
3, 3, 3, 3, 3, 13, 12, 2, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 5, 15, 3, 3, 3, 3, 3, 3, 
1, 1, 14, 10, 3, 3, 3, 3, 1, 1, 1, 1, 1, 9, 12, 13, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 12, 12, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 12, 12, 
1, 1, 9, 3, 3, 3, 3, 3, 7, 6, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 11, 2, 
3, 3, 3, 3, 3, 13, 16, 1, 3, 3, 3, 11, 9, 1, 1, 1, 
3, 8, 12, 1, 1, 1, 1, 1, 16, 1, 1, 1, 1, 1, 1, 1, 
3, 11, 16, 1, 1, 1, 1, 1, 3, 2, 1, 1, 1, 1, 1, 1, 
2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
8, 3, 3, 3, 3, 3, 3, 12, 14, 11, 3, 3, 3, 3, 3, 3, 
1, 14, 11, 3, 3, 3, 3, 3, 1, 1, 14, 8, 3, 3, 3, 3, 
1, 1, 1, 5, 15, 3, 3, 3, 1, 1, 1, 1, 1, 7, 8, 3, 
1, 1, 1, 1, 1, 1, 1, 9, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 8, 12, 1, 1, 1, 1, 1, 1, 
3, 3, 3, 10, 12, 5, 1, 1, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
6, 3, 3, 3, 3, 3, 3, 3, 1, 5, 12, 12, 11, 3, 3, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 12, 11, 
1, 1, 14, 12, 15, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 4, 2, 3, 3, 13, 12, 12, 1, 1, 1, 
4, 3, 3, 3, 3, 3, 8, 3, 3, 3, 3, 3, 3, 13, 2, 3, 
3, 3, 3, 3, 13, 5, 2, 3, 3, 3, 3, 15, 1, 1, 2, 3, 
3, 3, 12, 1, 1, 1, 2, 3, 13, 16, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 2, 3, 3, 3, 1, 1, 1, 1, 2, 3, 3, 3, 
1, 1, 1, 1, 2, 3, 3, 3, 1, 1, 1, 1, 2, 3, 3, 3, 
1, 1, 1, 1, 2, 3, 3, 3, 1, 1, 1, 1, 2, 3, 3, 3, 
1, 1, 1, 1, 2, 3, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 
3, 4, 1, 1, 1, 1, 1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 
3, 4, 1, 1, 1, 1, 1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 
3, 4, 1, 1, 1, 1, 1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 
3, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1, 
3, 3, 3, 15, 8, 3, 3, 3, 3, 3, 3, 4, 14, 11, 3, 3, 
3, 3, 3, 4, 1, 2, 3, 3, 3, 3, 3, 4, 1, 1, 14, 11, 
3, 3, 3, 4, 1, 1, 1, 16, 3, 3, 3, 4, 1, 1, 1, 1, 
3, 3, 3, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
3, 6, 14, 1, 1, 1, 1, 1, 3, 3, 3, 10, 16, 1, 1, 1, 
3, 3, 3, 3, 3, 13, 12, 2, 3, 3, 3, 3, 3, 3, 3, 3, 
6, 3, 3, 3, 3, 3, 3, 3, 1, 12, 3, 3, 3, 3, 3, 3, 
1, 1, 5, 12, 3, 3, 3, 3, 1, 1, 1, 1, 1, 2, 12, 15, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 7, 12, 6, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 10, 12, 
1, 1, 14, 6, 3, 3, 3, 3, 14, 4, 3, 3, 3, 3, 3, 3, 
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 9, 
3, 3, 3, 3, 3, 8, 14, 1, 3, 3, 3, 3, 10, 1, 1, 1, 
3, 11, 12, 5, 1, 1, 1, 1, 14, 1, 1, 1, 1, 1, 1, 1, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 3, 3, 12, 1, 1, 1, 1, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 3, 3, 12, 1, 1, 1, 1, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 3, 3, 12, 1, 1, 1, 1, 
3, 3, 3, 12, 1, 1, 1, 1, 3, 3, 3, 12, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 13, 13, 1, 
1, 1, 1, 1, 1, 13, 13, 1, 1, 1, 1, 1, 1, 13, 13, 1, 
1, 1, 1, 1, 1, 1, 12, 11, 1, 1, 1, 1, 1, 13, 11, 12, 
1, 1, 1, 1, 10, 3, 14, 1, 1, 1, 1, 1, 11, 4, 1, 1, 
1, 1, 1, 16, 3, 9, 1, 1, 1, 1, 1, 16, 3, 9, 1, 1, 
1, 1, 1, 1, 11, 4, 1, 1, 1, 1, 1, 1, 10, 3, 14, 1, 
3, 3, 8, 16, 4, 8, 1, 1, 1, 5, 6, 8, 13, 8, 1, 1, 
1, 1, 5, 6, 3, 8, 1, 1, 1, 1, 1, 5, 6, 8, 1, 1, 
1, 1, 1, 1, 12, 8, 1, 1, 1, 1, 1, 1, 12, 8, 1, 1, 
1, 1, 1, 5, 6, 8, 1, 1, 1, 1, 5, 6, 3, 8, 1, 1, 
1, 1, 4, 8, 1, 13, 11, 5, 1, 1, 4, 8, 13, 11, 14, 1, 
1, 1, 4, 3, 11, 14, 1, 1, 1, 1, 4, 11, 14, 1, 1, 1, 
1, 1, 4, 8, 1, 1, 1, 1, 1, 1, 4, 8, 1, 1, 1, 1, 
1, 1, 4, 8, 1, 1, 1, 1, 1, 1, 4, 8, 1, 1, 1, 1, 
1, 1, 14, 6, 3, 3, 10, 1, 1, 1, 6, 8, 5, 2, 8, 14, 
1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 6, 11, 14, 1, 1, 1, 
1, 1, 14, 8, 3, 15, 1, 1, 1, 1, 1, 1, 12, 3, 8, 5, 
1, 1, 1, 1, 1, 2, 3, 10, 1, 1, 1, 1, 1, 1, 3, 4, 
1, 1, 1, 1, 1, 2, 13, 3, 1, 1, 1, 1, 7, 3, 15, 5, 
1, 1, 1, 16, 11, 10, 1, 1, 1, 1, 1, 12, 3, 5, 1, 1, 
1, 1, 1, 15, 3, 3, 3, 3, 1, 1, 1, 15, 6, 1, 1, 1, 
1, 1, 1, 12, 3, 5, 1, 1, 1, 1, 1, 16, 3, 10, 1, 1, 
3, 3, 4, 16, 1, 1, 1, 1, 1, 14, 6, 11, 14, 1, 1, 1, 
1, 1, 1, 15, 8, 1, 1, 1, 1, 1, 1, 2, 3, 14, 1, 1, 
3, 3, 3, 3, 3, 9, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 15, 4, 1, 1, 1, 
1, 16, 3, 9, 2, 3, 3, 3, 1, 16, 3, 4, 3, 4, 1, 14, 
1, 16, 3, 3, 4, 1, 1, 1, 1, 16, 3, 4, 1, 1, 1, 1, 
1, 16, 3, 9, 1, 1, 1, 1, 1, 16, 3, 9, 1, 1, 1, 1, 
1, 16, 3, 9, 1, 1, 1, 1, 1, 16, 3, 9, 1, 1, 1, 1, 
4, 1, 1, 1, 1, 1, 1, 1, 8, 4, 1, 1, 1, 1, 1, 2, 
12, 3, 5, 1, 1, 1, 16, 11, 2, 3, 2, 1, 1, 1, 12, 3, 
16, 3, 2, 1, 1, 1, 4, 8, 16, 3, 9, 1, 1, 1, 4, 8, 
16, 3, 9, 1, 1, 1, 12, 3, 16, 3, 9, 1, 1, 1, 16, 11, 
14, 13, 3, 3, 3, 12, 16, 3, 3, 13, 16, 1, 9, 3, 4, 3, 
15, 1, 1, 1, 1, 9, 3, 3, 16, 1, 1, 1, 1, 1, 9, 3, 
1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 
16, 1, 1, 1, 1, 1, 9, 3, 15, 1, 1, 1, 1, 9, 3, 3, 
9, 1, 1, 1, 1, 13, 13, 1, 9, 1, 1, 1, 1, 13, 13, 1, 
9, 1, 1, 1, 1, 13, 13, 1, 9, 1, 1, 1, 1, 13, 13, 1, 
9, 1, 1, 1, 1, 13, 13, 1, 9, 1, 1, 1, 1, 13, 13, 1, 
9, 1, 1, 1, 1, 13, 13, 1, 9, 1, 1, 1, 1, 13, 13, 1, 
1, 1, 1, 1, 1, 13, 11, 12, 1, 1, 1, 1, 1, 1, 12, 11, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 5, 6, 8, 13, 8, 1, 1, 3, 3, 8, 16, 4, 8, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 4, 8, 1, 1, 1, 1, 1, 1, 4, 8, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 14, 8, 2, 1, 12, 3, 2, 1, 1, 4, 3, 3, 11, 12, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 9, 3, 15, 1, 1, 1, 1, 1, 1, 2, 6, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 14, 13, 3, 2, 1, 1, 1, 3, 3, 15, 14, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 16, 3, 9, 1, 1, 1, 1, 1, 16, 3, 9, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
16, 3, 9, 1, 1, 1, 1, 2, 16, 3, 9, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
3, 13, 16, 1, 9, 3, 4, 3, 14, 13, 3, 3, 3, 12, 16, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 16, 3, 4, 1, 1, 1, 1, 
9, 1, 1, 1, 1, 13, 13, 1, 9, 1, 1, 1, 1, 13, 13, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 4, 8, 1, 13, 1, 1, 1, 1, 4, 8, 13, 11, 
1, 1, 1, 1, 4, 3, 11, 14, 1, 1, 1, 1, 4, 11, 14, 1, 
1, 1, 1, 1, 4, 8, 1, 1, 1, 1, 1, 1, 4, 8, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
3, 3, 3, 4, 5, 1, 1, 1, 14, 1, 14, 6, 8, 16, 1, 1, 
1, 1, 1, 1, 6, 6, 1, 1, 1, 1, 1, 1, 7, 3, 2, 1, 
1, 1, 1, 1, 5, 3, 12, 1, 1, 1, 1, 1, 5, 3, 12, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 4, 8, 1, 13, 11, 5, 1, 1, 4, 8, 13, 11, 14, 1, 
1, 1, 4, 3, 11, 14, 1, 1, 1, 1, 4, 11, 14, 1, 1, 1, 
1, 1, 4, 8, 1, 1, 1, 1, 1, 1, 4, 8, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 9, 6, 3, 3, 1, 1, 1, 12, 3, 4, 1, 1, 
1, 1, 7, 3, 12, 1, 1, 1, 1, 1, 13, 6, 1, 1, 1, 1, 
1, 1, 11, 10, 1, 1, 1, 1, 1, 1, 11, 10, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
11, 10, 1, 1, 1, 1, 1, 1, 9, 11, 6, 1, 1, 1, 1, 1, 
1, 16, 11, 10, 1, 1, 1, 1, 1, 1, 10, 3, 5, 1, 1, 1, 
1, 1, 7, 3, 2, 1, 1, 1, 1, 1, 7, 3, 2, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 9, 6, 3, 3, 3, 2, 1, 10, 3, 4, 1, 1, 4, 3, 
7, 3, 7, 1, 1, 1, 1, 4, 13, 6, 1, 1, 1, 1, 1, 1, 
11, 10, 1, 1, 1, 1, 1, 1, 3, 12, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
9, 3, 16, 1, 1, 1, 4, 8, 10, 3, 16, 1, 1, 1, 4, 8, 
3, 3, 16, 1, 1, 1, 4, 3, 4, 3, 16, 1, 1, 1, 4, 11, 
9, 3, 16, 1, 1, 1, 4, 8, 9, 3, 16, 1, 1, 1, 4, 8, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 13, 11, 5, 1, 1, 1, 1, 13, 11, 14, 1, 1, 1, 1, 12, 
11, 14, 1, 1, 1, 1, 7, 3, 14, 1, 1, 1, 1, 1, 15, 8, 
1, 1, 1, 1, 1, 1, 8, 4, 1, 1, 1, 1, 1, 1, 8, 4, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
9, 6, 3, 3, 3, 2, 9, 3, 3, 4, 1, 1, 4, 3, 4, 3, 
12, 1, 1, 1, 1, 4, 3, 3, 1, 1, 1, 1, 1, 1, 4, 3, 
1, 1, 1, 1, 1, 1, 2, 3, 1, 1, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
16, 1, 1, 1, 1, 8, 4, 16, 16, 1, 1, 1, 1, 8, 13, 8, 
16, 1, 1, 1, 1, 8, 3, 6, 16, 1, 1, 1, 1, 8, 6, 5, 
16, 1, 1, 1, 1, 8, 4, 1, 16, 1, 1, 1, 1, 8, 4, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
8, 3, 3, 10, 1, 5, 15, 3, 6, 5, 9, 3, 10, 8, 4, 1, 
5, 1, 1, 15, 3, 4, 1, 1, 1, 1, 1, 12, 3, 14, 1, 1, 
1, 1, 1, 12, 3, 16, 1, 1, 1, 1, 1, 12, 3, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
3, 6, 14, 1, 1, 1, 1, 1, 5, 6, 8, 1, 1, 1, 1, 1, 
1, 14, 3, 7, 1, 1, 1, 1, 1, 5, 3, 12, 1, 1, 1, 1, 
1, 1, 3, 12, 1, 1, 1, 1, 1, 1, 3, 12, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
4, 8, 1, 13, 3, 3, 13, 5, 4, 8, 13, 11, 14, 14, 8, 13, 
4, 3, 11, 14, 1, 1, 12, 3, 4, 11, 14, 1, 1, 1, 2, 3, 
4, 8, 1, 1, 1, 1, 2, 3, 4, 8, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 12, 3, 3, 8, 9, 1, 1, 15, 6, 5, 1, 4, 3, 16, 1, 
8, 1, 1, 1, 1, 11, 10, 1, 12, 1, 1, 1, 1, 6, 15, 1, 
9, 1, 1, 1, 1, 13, 13, 1, 2, 1, 1, 1, 1, 13, 13, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 10, 11, 3, 1, 1, 1, 1, 6, 8, 9, 1, 
1, 1, 1, 10, 11, 16, 1, 1, 1, 1, 5, 11, 10, 1, 1, 1, 
1, 1, 14, 3, 3, 3, 3, 3, 1, 1, 14, 3, 7, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
3, 6, 12, 1, 1, 1, 1, 1, 1, 12, 3, 4, 1, 1, 1, 1, 
1, 1, 14, 3, 9, 1, 1, 1, 1, 1, 1, 13, 15, 1, 1, 1, 
3, 3, 3, 3, 8, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
16, 3, 9, 2, 3, 12, 1, 1, 16, 3, 4, 3, 4, 1, 1, 1, 
16, 3, 3, 4, 1, 1, 1, 1, 16, 3, 4, 1, 1, 1, 1, 1, 
16, 3, 9, 1, 1, 1, 1, 1, 16, 3, 9, 1, 1, 1, 1, 1, 
1, 16, 3, 4, 1, 1, 1, 1, 1, 1, 12, 10, 1, 1, 1, 1, 
1, 1, 6, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 14, 6, 3, 3, 10, 1, 1, 1, 6, 8, 5, 2, 8, 14, 1, 
1, 3, 4, 1, 1, 1, 1, 1, 1, 6, 11, 14, 1, 1, 1, 1, 
1, 14, 8, 3, 15, 1, 1, 1, 1, 1, 1, 12, 3, 8, 5, 1, 
1, 1, 1, 1, 4, 11, 14, 1, 1, 1, 1, 1, 4, 3, 11, 14, 
1, 1, 1, 1, 4, 8, 13, 11, 1, 1, 1, 1, 4, 8, 1, 13, 
1, 1, 1, 1, 4, 8, 1, 1, 1, 1, 1, 1, 4, 8, 1, 1, 
1, 1, 1, 1, 4, 8, 1, 1, 1, 1, 1, 1, 4, 8, 1, 1, 
1, 1, 1, 1, 7, 3, 14, 1, 1, 1, 1, 1, 8, 6, 1, 1, 
14, 1, 2, 6, 11, 16, 1, 1, 3, 3, 3, 4, 5, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 4, 8, 1, 1, 1, 1, 1, 1, 4, 8, 1, 1, 1, 1, 
1, 1, 4, 8, 1, 1, 1, 1, 1, 1, 4, 8, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 13, 6, 1, 1, 1, 1, 1, 1, 7, 3, 7, 1, 1, 1, 
1, 1, 1, 10, 3, 12, 1, 1, 1, 1, 1, 1, 9, 6, 3, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 10, 3, 5, 1, 1, 1, 1, 16, 11, 4, 1, 1, 1, 1, 
9, 8, 6, 5, 1, 1, 1, 1, 11, 10, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
6, 15, 1, 1, 1, 1, 1, 1, 9, 3, 14, 1, 1, 1, 1, 4, 
1, 4, 11, 12, 1, 1, 4, 3, 1, 1, 12, 8, 3, 3, 3, 2, 
1, 1, 1, 1, 1, 1, 1, 1, 4, 8, 5, 1, 1, 1, 1, 5, 
5, 8, 6, 9, 1, 1, 9, 6, 1, 1, 10, 11, 3, 3, 3, 4, 
4, 3, 16, 1, 1, 1, 4, 8, 3, 3, 16, 1, 1, 1, 4, 8, 
10, 3, 16, 1, 1, 1, 4, 8, 9, 3, 5, 1, 1, 1, 4, 8, 
10, 11, 1, 1, 1, 1, 1, 1, 8, 4, 1, 1, 1, 1, 1, 1, 
8, 16, 1, 1, 1, 1, 1, 1, 5, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 15, 8, 1, 1, 1, 1, 1, 1, 7, 3, 
1, 1, 1, 1, 1, 1, 1, 12, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 4, 3, 12, 1, 1, 1, 1, 4, 3, 3, 
3, 4, 1, 1, 4, 3, 4, 3, 9, 6, 3, 3, 3, 2, 9, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
16, 1, 1, 1, 1, 8, 4, 1, 16, 1, 1, 1, 1, 8, 4, 1, 
16, 1, 1, 1, 1, 8, 4, 1, 16, 1, 1, 1, 1, 8, 4, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 12, 3, 1, 1, 1, 1, 1, 1, 12, 3, 1, 1, 1, 
1, 1, 1, 12, 3, 1, 1, 1, 1, 1, 1, 12, 3, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 3, 12, 1, 1, 1, 1, 1, 1, 3, 12, 1, 1, 1, 1, 
1, 1, 3, 12, 1, 1, 1, 1, 1, 1, 3, 12, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
4, 8, 1, 1, 1, 1, 2, 3, 4, 8, 1, 1, 1, 1, 2, 3, 
4, 8, 1, 1, 1, 1, 2, 3, 4, 8, 1, 1, 1, 1, 2, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
2, 1, 1, 1, 1, 13, 13, 1, 2, 1, 1, 1, 1, 13, 13, 1, 
2, 1, 1, 1, 1, 13, 13, 1, 2, 1, 1, 1, 1, 13, 13, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 5, 11, 10, 1, 1, 1, 1, 1, 1, 4, 11, 16, 1, 1, 
1, 1, 1, 5, 6, 8, 2, 1, 1, 1, 1, 1, 1, 10, 3, 3, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 14, 11, 14, 1, 1, 1, 
1, 12, 11, 13, 1, 1, 1, 1, 3, 8, 12, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
16, 3, 9, 1, 1, 1, 1, 1, 16, 3, 9, 1, 1, 1, 1, 1, 
16, 3, 9, 1, 1, 1, 1, 1, 16, 3, 9, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 2, 3, 10, 1, 1, 1, 1, 1, 1, 3, 4, 1, 
14, 8, 2, 1, 12, 3, 2, 1, 1, 4, 3, 3, 11, 12, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
};


	   
	   
	   
	   
#ifdef __cplusplus
}
#endif


